/*****************************************************************************
 * 
 * NAME: CheckI.c
 *
 * DESCRIPTION: The functions in this file will do the validation process for all 
 *               the values of Aggrgates parmeteres. 
 *     
 *
 *
 * REVISION HISTORY:
 *     07/29/00  Amer Rahabi
 *
 ****************************************************************************/
#include <stdio.h>
/* 
 */

#include <stdlib.h>
#include <ctype.h>
#include "odldef.h"
#include "odlinter.h"
#include "metcheck.h"
#include "CheckI.h"
#include "odlFieldList.h"

/*****************************************************************************
 * 
 * NAME: CheckNormal.c
 *
 * DESCRIPTION: This function will check if any extra aggregate in .met file existes and call functions
 *              to check the values of Aggrgates parmeteres 
 *     
 *
 * PARAMETERS:
 *     pRootF1 (AGGREGATE)     pointer to the first odl label root (.met file).
 *     
 *     pRootF2 (AGGREGATE)     pointer to the second odl label root (.desc file).
 *    
 *     output (FILE)           pointer to the out put file.
 *
 * RETURN VALUE:
 *     
 *          
 * GLOBAL VARIABLES:
 *     None.
 *	
 *              
 *
 * NOTES:
 *
 *
 *
 * REVISION HISTORY:
 *     07/29/00  Amer Rahabi
 *
 ****************************************************************************/

/* GLOBAL VARIABLES: the following variables may be used in other files.*/

   long NumVal;

int CheckNormal(AGGREGATE  pRootF1,AGGREGATE  pRootF2, FILE *OUTput)
{
  int Failure = 0;
  int Success = 0;
 
 /* int s; */
 /* AGGREGATE descRoot = NULL; */
  AGGREGATE nextAg = NULL;
  AGGREGATE invmetG = NULL;
  AGGREGATE invdscG, refAgg = NULL;
 int passNV, passVT = 0;
 int passVal = 0;
 int pass = 1 ;
/*  FILE *descFile;

  
do we have the the right groups */
  invmetG = FindGroup(pRootF1,"INVENTORYMETADATA");
  if(invmetG == NULL){
     checkFatalError ( "The .met file",
                   "the tool unable to find the main aggregate INVENTORYMETADATA" );
      return Failure;
  }
  invdscG = FindGroup(pRootF2,"INVENTORYMETADATA");
  if(invdscG == NULL){
     checkFatalError ( "The .dsc file",
                   "the tool unable to find the main aggregate INVENTORYMETADATA" );
      return Failure;
  }
  nextAg = NextAggregate(invmetG);
/* out put header information for this section */
  checkHeader( " Errors --- Normal Aggrgates Section ");
  
  while(nextAg) {

    NumVal = 0;

  /* find if any Agg is not in the desc file */
  
    refAgg =FindAggregate (invdscG,nextAg->name);
    if( refAgg == NULL){
      if (!( (strcmp(nextAg->name , "ADDITIONALATTRIBUTES") == 0) ||
        (strcmp(nextAg->name , "ADDITIONALATTRIBUTESCONTAINER") == 0) ||
        (strcmp(nextAg->name , "ADDITIONALATTRIBUTENAME") == 0) ||
        (strcmp(nextAg->name , "INFORMATIONCONTENT") == 0) ||
        (strcmp(nextAg->name , "PARAMETERVALUE") == 0) ))
      {
        fprintf (OUTput,"ERROR  :: The Aggeragate  = %s   Was not found in the .desc file\n", nextAg->name);
        pass = 0 ;
      }
    }
    /* start checking the values of each aggeragate     */
    else{
    /*      if (FindParameter (nextAg,"CLASS") == NULL){ */
        if (!(FindParameter (nextAg,"VALUE")== NULL))
        {
         
          /*  Start the checking proccess */
          
         
          if ( (passNV = CheckNumVal(nextAg, refAgg, OUTput)) != Success){
          checkWarnings( "CheckNumVal",
                   "Warning  :: some errors were found while checking " );
          pass = 0;
          }
          if ( (passVT = CheckValType(nextAg, refAgg, OUTput)) != Success){
          checkWarnings( "CheckNumVal",
                   "Warning  :: some errors were found while checking " );
          pass = 0;
          }
          if ( (passVal = CheckValue(nextAg, refAgg, OUTput)) != Success){
          checkWarnings( "CheckNumVal",
                   "Warning  :: some errors were found while checking " );
          pass = 0;
          }
                
        }
      
    }
    nextAg = NextAggregate(nextAg);
  }/* end of while control loop */

/* return to the calling function for debug information */
  if (pass)
     return Success;
   else
     return Failure;


}

/* end of CheckNoraml  */

/************************************************************/

/*****************************************************************************
 * 
 * NAME: checkPSA
 *
 *
 *
 * NOTES:
 *
 *
 *
 * REVISION HISTORY:
 *     08/22/00  Amer Rahabi(updated )
 *                added return an int value.
 *                added another input to pass FILE output.
 *                created output messages.
 *                added status variables Failure, Success, and pass .
 *                return status Failure in some control.
 *                added a return status section to the calling function
 *                Added a call to checkHeader().
 *     08/  /00  Ted Johnson
 *
 ****************************************************************************/

int checkPSA(lstLIST fldList, AGGREGATE startAgg, AGGREGATE descAgg, FILE *OUTput)
{
  descList fldEntry;
 
  int Failure = 0;
  int Success = 0;
  int pass = 1;
 
  char attName[100];
  int conNum, i;

  VALUE pValue = NULL;
  PARAMETER pName,valParm,numValParm = NULL;
  AGGREGATE descObject, descPsaAgg,psaAgg,psaCon,attNameAgg,attInfoAgg,
	        attValAgg = NULL;

  /* out put header information for this section */
  checkHeader( " Errors --- PSA Aggrgates Section ");
 
  fldEntry = getFldEntry(TRUE, fldList);
  psaAgg = FindGroup(startAgg,"ADDITIONALATTRIBUTES",NULL);

  if(psaAgg == NULL) {
/*	  printf(" Additional Attributes Group Missing from MET file"); (updated)*/ 
    fprintf (OUTput,"ERROR  ::  Additional Attributes Group Missing from MET file");
        pass = 0 ;
      return Failure;
  }

   descPsaAgg = FindGroup(descAgg,"PRODUCTSPECIFICMETADATA",NULL);
 
  if(descPsaAgg == NULL) {
/*	  printf("ProductSpecificMetadata Group missing from the descriptor  file\n"); (updated)*/
    fprintf (OUTput,"ERROR  :: ProductSpecificMetadata Group missing from the descriptor  file\n");
        pass = 0 ;
      return Failure;
   }
  while(fldEntry) 
  {
	   if(fldEntry->fieldMandatory) 
     {
		   if(!addAttributeExists(psaAgg, fldEntry->fieldName)) 
       {

/*			   printf("Mandatory PSA %s is missing from the Met File\n",fldEntry->fieldName); (updated) */
        fprintf (OUTput,"ERROR  :: Mandatory PSA %s is missing from the Met File\n",fldEntry->fieldName);
        pass = 0 ;
           }
	   }
	   fldEntry = getFldEntry(FALSE, fldList);
   }
	   

   /* Check Each Met PSA */
  
  psaCon = FindObject(psaAgg,"ADDITIONALATTRIBUTESCONTAINER",NULL);
  conNum = 0;
  while(psaCon != NULL) 
  {
      ++conNum;
	  attNameAgg = FindNextObject(psaCon,psaCon,"ADDITIONALATTRIBUTENAME",NULL);
	  if(attNameAgg)
    {
	    pName = FindParameter(attNameAgg,"VALUE");
	    if(pName) 
      {
            pValue = FirstValue(pName);
            strcpy(attName,pValue->item.value.string);
			    for (i = 0; attName[i] != '\0' ; i++)
                 attName[i] = (unsigned char) toupper ( (int) attName[i]);
              attInfoAgg = FindNextGroup(psaCon,psaCon,"INFORMATIONCONTENT",NULL);
        if(attInfoAgg) 
        {
	              attValAgg = FindNextObject(psaCon,psaCon,"PARAMETERVALUE",NULL);
				  if(attValAgg) 
          {
				     descObject = FindObject(descPsaAgg,attName,NULL);
				     valParm = FindParameter(attValAgg,"VALUE");
             numValParm = FindParameter(attValAgg,"NUM_VAL");
  /*				   validatePsa(attName,valParm,numValParm, descObject, output); (updated) */
            if( ValidatePsa(attName,attValAgg, descObject, OUTput) )
              pass = 0;
				  }
				  else {
  /*					printf("PSA Parameter Value Missing from CLASS %d\n",conNum); (updated) */
          fprintf (OUTput,"ERROR  :: PSA Parameter Value Missing from CLASS %d\n",conNum);
          pass = 0 ;
				  }
			  }
			  else 
        { /* else for if(attInfoAgg)  */
				  /*printf("PSA  Information Content Group Missing from CLASS %d\n",conNum); (updated) */
          fprintf (OUTput,"ERROR  :: PSA  Information Content Group Missing from CLASS %d\n",conNum);
          pass = 0 ;

         }
		  }
		else 
    { /*else for if(pName) */
			/*printf("PSA Parameter Name value Missing from CLASS %d\n",conNum); (updated) */
      fprintf (OUTput,"ERROR  :: PSA Parameter Name value Missing from CLASS %d\n",conNum);
        pass = 0 ;
    }
	}
	else 
  { /* else for (attNameAgg) */
		/*printf("PSA Additional Attribute Name Missing from CLASS %d\n",conNum); (updated ) */
    fprintf (OUTput,"ERROR  :: PSA Additional Attribute Name Missing from CLASS %d\n",conNum);
        pass = 0 ;
    }
    psaCon = FindNextObject(psaAgg,psaCon,"ADDITIONALATTRIBUTESCONTAINER",NULL);
  } /* end of while(psaCon != NULL) */

/* return to the calling function for debug information */
  if (pass)
     return Success;
   else
     return Failure;

}


/************************************************************/

/*****************************************************************************
 * 
 * NAME: ValidatePsa
 *
 * DESCRIPTION: This function validate that all additional Attributes are in the desc file and call functions
 *              to check the values of the additional Attributes Aggrgates parmeteres 
 *     
 *
 * PARAMETERS:
 *     *attName (char)         pointer to the name of the additional attribute name (.met file).
 *        
 *     valParm (PARAMETER)     pointer to the VALUE parameter (.met file).
 *  
 *     numValParm (PARAMETER)  pointer to the NUM_VAL parameter (.met file).
 *  
 *     descPSA (AGGREGATE)     pointer to the matching PSA Aggragate (.desc file).
 *    
 *     output (FILE)           pointer to the out put file.
 *
 * RETURN VALUE:
 *     
 *          
 * GLOBAL VARIABLES:
 *     None.
 *	
 *              
 *
 * NOTES:
 *
 *
 *
 * REVISION HISTORY:
 *     08/22/00  Amer Rahabi
 *
 ****************************************************************************/

int ValidatePsa(char *attName,AGGREGATE metAA, AGGREGATE descPSA, FILE *OUTput)
{

  int Failure = 0;
  int Success = 0;

  
/*  AGGREGATE nextAg = NULL;
  AGGREGATE invmetG = NULL;
  AGGREGATE invdscG, refAgg = NULL; */
 int passNV, passVT = 0;
 int passVal = 0;
 int pass = 1 ;

/* Must check for NULL valParm, numValParm and descPSA  */

if( descPSA == NULL )
{
   fprintf(OUTput,"ERROR :: The Additional Attribute  :: %s  was not found in .desc file\n",attName);
    pass = 0;
}

          /*  Start the checking proccess */
          
         
          if ( (passNV = CheckNumVal(metAA, descPSA, OUTput)) != Success){
          checkWarnings( "CheckNumVal",
                   "Warning  :: some errors were found while checking " );
          pass = 0;
          }
          if ( (passVT = CheckValType(metAA, descPSA, OUTput)) != Success){
          checkWarnings( "CheckNumVal",
                   "Warning  :: some errors were found while checking " );
          pass = 0;
          }
          if ( (passVal = CheckValue(metAA, descPSA, OUTput)) != Success){
          checkWarnings( "CheckNumVal",
                   "Warning  :: some errors were found while checking " );
          pass = 0;
          }
                


/* return to the calling function for debug information */
  if (pass)
     return Success;
   else
     return Failure;


  


/* end of CheckNoraml  */

/************************************************************/

}

